import greenfoot.*;  // （World、Actor、GreenfootImage、GreenfootSound、Greenfoot及MouseInfo）
import java.util.ArrayList;
import java.util.List;

/**
 * 桌面。
 * 
 * @author 依瑪貓
 * @version 2012/6/16
 */
public class Table extends World
{
    /** 燈泡的初始狀態。 */
    private final static int bulb[][] =
        {   {-1,-1, 1, 1},
            {-1, 1, 1, 1},
            { 1, 1, 1, 1},
            { 1, 1, 1, 1}
        };
    
    /**
     * 建立一張新的桌面。
     * 
     */
    public Table()
    {    
        // 建立4x4方格的新世界，方格大小為64x64像素。
        super(4, 4, 64);
        // 加上燈泡。
        for (int i = 0; i < bulb.length; i++)
        {
            for (int j = 0; j < bulb[i].length; j++)
            {
                // 1 表示燈是亮的。
                if (bulb[i][j] == 1)
                {
                    addObject(new Light(true), j, i);
                }
                // -1 表示燈是暗的。
                else if (bulb[i][j] == -1)
                {
                    addObject(new Light(false), j, i);
                }
            }
        }
    }
    
    /**
     * 每一回合執行的動作。
     * 
     */
    public void act() 
    {
        List<Light> lights = getObjects(Light.class);
        boolean isAllOn = true;
        for (Light light : lights)
        {
            isAllOn = isAllOn & light.isOn();
        }
        if (isAllOn)
        {
            addObject(new Text("過關"), 1, 1);
            Greenfoot.stop();
        }
    }
}